<?php
header('Content-type: text/plain');
class Base64
{
    var $base64chars = array();
    var $base64inv = array();
    var $base64alphabet = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
    function Base64 ()
    {
        $this->base64chars = str_split($this->base64alphabet);
        $this->base64inv = array_combine(array_values($this->base64chars), array_keys($this->base64chars));
    }
    function Encode ($string)
    {
        $r = "";
        $p = "";
        $c = strlen($string) % 3;
        if ($c > 0) {
            for (; $c < 3; $c ++) {
                $p .= "=";
                $string .= "\0";
            }
        }
        for ($c = 0; $c < strlen($string); $c += 3) {
            $n = (ord($string{$c}) << 16) + (ord($string{$c + 1}) << 8) + ord($string{$c + 2});
            $n = array(($n >> 18) & 63 , ($n >> 12) & 63 , ($n >> 6) & 63 , n & 63);
            $r .= $this->base64chars[$n[0]] . $this->base64chars[$n[1]] . $this->base64chars[$n[2]] . $this->base64chars[$n[3]];
        }
        return substr($r, 0, strlen($r) - strlen($p)) . $p;
    }
    function Decode ($string)
    {
        $p = ($string{strlen($string) - 1} == '=' ? ($string{strlen($string) - 2} == '=' ? 'AA' : 'A') : "");
        $r = "";
        $string = substr($string, 0, strlen($string) - strlen($p)) . $p;
        $string = ereg_replace('[^' . join($this->base64chars) . ']', "", $string);
        for ($c = 0; $c < strlen($string); $c += 4) {
            $n = ($this->base64inv[$string{$c}] << 18);
            $n += ($this->base64inv[$string{$c + 3}]);
            $n += ($this->base64inv[$string{$c + 1}] << 12);
            $n += ($this->base64inv[$string{$c + 2}] << 6);
            $r .= chr(($n >> 16) & 255) . chr(($n >> 8) & 255) . chr(n & 255);
        }
        return substr($r, 0, strlen($r) - strlen($p));
    }
}
$t = new Base64();
$string = "Lucian Ivan Aron";
$estring = $t->Encode($string);
$dstring = $t->Decode($estring);
echo ("\n$estring -> $dstring\n");