<?php
class Custom_TbtToObj
{
    const DATE_FORMAT = "m/d/Y";
    const TIME_FORMAT = "H:i:s";
    public $daysToNumber = array("Monday" => 1 , "Tuesday" => 2 , "Wednesday" => 3 , "Thursday" => 4 , "Friday" => 5 , "Saturday" => 6 , "Sunday" => 7);
    public $numberToDays = array(1 => "Monday" , 2 => "Tuesday" , 3 => "Wednesday" , 4 => "Thursday" , 5 => "Friday" , 6 => "Saturday" , 7 => "Sunday");
    public $span = false;
    public $taskTypes = array(0 => "floppy_folder" , 1 => "local_folder" , 2 => "lan_folder" , 3 => "ftp_folder" , 4 => "cd_folder" , 10 => "sync_floppy" , 11 => "sync_local" , 12 => "sync_lan" , 13 => "sync_ftp" , 14 => "sync_floppy");
    private $rObject;
    function cNumberToDays ($number)
    {
        $numbers = str_split($number, 1);
        foreach ($numbers as $value) {
            $days[] = $this->numberToDays[$value];
        }
        return $days;
    }
    function xorCrypt ($text, $key)
    {
        $tLen = strlen($text);
        $kLen = strlen($key);
        $kPos = 0;
        $newString = "";
        for ($pos = 0; $pos < $tLen; $pos ++) {
            $tChr = ord(substr($text, $pos, 1));
            if ($kPos > $kLen - 1)
                $kPos = 0;
            $kChr = ord(substr($key, $kPos, 1));
            $newString .= chr($tChr ^ $kChr);
            $kPos ++;
        }
        return $newString;
    }
    function autoReseter ($cIndex, &$array)
    {
        //$nextDay = $runDays[(($currentPos+1==$totalDays&&$schedTime<$currentTime)?$currentPos+2:$currentPos+1)<=$totalDays?$currentPos+1:0];
        reset($array);
        while (current($array) != $cIndex) {
            each($array);
        }
    }
    function setter (&$var, $val)
    {
        $value = (string) $val;
        if (empty($value)) {
            $var = null;
            return false;
        } else {
            $var = $value;
            return $var;
        }
    }
    function DateTimeToUnixTime ($time)
    {
        $tdUnixStartDate = 25569.0;
        $time = bcmul(bcsub($time, $tdUnixStartDate, 15), 86400, 15);
        return floor($time);
    }
    function getDateTime ($date, $time)
    {
        $uDate = $this->DateTimeToUnixTime($date);
        $uTime = $this->DateTimeToUnixTime($time);
        $result = array("date" => gmdate(self::DATE_FORMAT, $uDate) , "time" => gmdate(self::TIME_FORMAT, $uTime));
        return $result;
    }
    function convert ($xmlString)
    {
        /*
    	 * Bit of options
    	 * must reanalize this
    	 * @todo Reanalize/remove spaghetti code
    	 */
        $this->rObject = array();
        $xml = simplexml_load_string($xmlString);
        $this->setter(&$this->rObject['task_general']['task_name'], $xml->GENERAL->Name);
        $this->setter(&$this->rObject['task_general']['dest_name'], $xml->GENERAL->ArchiveFolderName);
        $this->setter(&$this->rObject['task_general']['task_description'], $xml->GENERAL->Description);
        $this->setter(&$this->rObject['task_general']['notification_email'], $xml->GENERAL->Email);
        $this->setter(&$this->rObject['task_options']['backupCreationType'], $xml->GENERAL->SetCollision);
        $this->setter(&$this->rObject['task_options']['stackLastFiles'], $xml->GENERAL->SetCollision["purge"]);
        $this->setter(&$this->rObject["task_options"]["stackFileLimit"], $xml->GENERAL->CountStacks);
//        switch ((string) $xml->GENERAL->ItemCollision) {
//            case "version":
//                $this->setter(&$this->rObject['task_options']['incrementalMode'], "true");
//                $this->setter(&$this->rObject['task_options']['differentialMode'], "");
//                break;
//            default:
//                break;
//        }
        if ($xml->GENERAL->ItemCollision == "version" && $xml->GENERAL->SetCollision == "replace" || $xml->GENERAL->ItemCollision == "full") 
                        $this->setter(&$this->rObject['task_options']['incrementalMode'], "true");
        
        if ($xml->GENERAL->StartRunPath != "")
            $this->setter(&$this->rObject['task_events']['runBefore'], "true");
        if ($xml->GENERAL->EndRunPath != "")
            $this->setter(&$this->rObject['task_events']['runAfter'], "true");
        $this->setter(&$this->rObject['task_events']['runBeforeCmd'], $xml->GENERAL->StartRunPath);
        $this->setter(&$this->rObject['task_events']['runAfterCmd'], $xml->GENERAL->EndRunPath);
        //$this->setter(&$this->rObject['task_events']['notifyErrors_showWindow'], $xml->GENERAL->OnError-Show);
        foreach ($xml->GENERAL[0] as $element => $value) {
            switch ($element) {
                case 'OnError-show':
                    if ($value == "Popup")
                        $this->setter($this->rObject["task_events"]['notifyErrors_showWindow'], "true");
                    $this->setter($this->rObject["task_events"]['notifyErrors_playSound'], $value["play"]);
                    $this->setter($this->rObject["task_events"]['notifyErrors_sendEmail'], $value["email"]);
                    break;
                case 'OnWarning-show':
                    if ($value == "Popup")
                        $this->setter($this->rObject["task_events"]['notifyWarnings_showWindow'], "true");
                    $this->setter($this->rObject["task_events"]['notifyWarnings_playSound'], $value["play"]);
                    $this->setter($this->rObject["task_events"]['notifyWarnings_sendEmail'], $value["email"]);
                    break;
                case 'OnSummary-show':
                    if ($value == "Popup")
                        $this->setter($this->rObject["task_events"]['notifySummary_showWindow'], "true");
                    $this->setter($this->rObject["task_events"]['notifySummary_playSound'], $value["play"]);
                    $this->setter($this->rObject["task_events"]['notifySummary_sendEmail'], $value["email"]);
                    break;
            }
        }
        if ($xml->GENERAL->SRunMissed == "true")
            $this->setter($this->rObject["task_scheduler"]["rescheduleMissed"], "true");
        if ($xml->GENERAL->Split == "true") {
            $this->setter($this->rObject["task_options"]["splitArchives"], "true");
            $this->setter($this->rObject["task_options"]["useCompression"], "zip");
        }
        if ($xml->GENERAL->Complementary == "true" && $xml->GENERAL->ItemCollision == "full")
            $this->setter($this->rObject["task_options"]["differentialMode"], "true");
            
        if ($xml->GENERAL->ShutDown == "true")
            $this->setter($this->rObject["task_events"]["shutdownAfter"], "true");
        if ($xml->GENERAL->LogOff == "true")
            $this->setter($this->rObject["task_events"]["logoffAfter"], "true");
        if ($xml->GENERAL->VerifyBackup == "true")
            $this->setter($this->rObject["task_events"]["verifyBackup"], "true");
        /**
         *  Source
         **/
        $tbtSource = $xml->SOURCE;
        $path1 = $tbtSource->folder;
        $path2 = $tbtSource->file;
        foreach ($path1 as $path) {
            $this->setter($this->rObject["task_source"]["backupFiles"], "true");
            $this->setter($this->rObject["task_source"]["paths"][], addslashes($path->path));
        }
        foreach ($path2 as $path) {
            $this->setter($this->rObject["task_source"]["backupFiles"], "true");
            $this->setter($this->rObject["task_source"]["paths"][], addslashes($path->path));
        }
        /**
         * Search masks
         **/
        $searchMasks = $tbtSource->SearchMaskS;
        foreach ($searchMasks as $searchMask) {
            $this->setter($this->rObject["task_source"]["searchMasks"], "true");
            $sValue = $searchMask->SearchMask;
            $sDescription = $sValue["description"];
            $this->rObject["task_source"]["masks"][(string) $sDescription] = (string) $sValue;
        }
        /**
         * Registry
         **/
        $registryBackup = $xml->REGISTRY;
        $registryKeys = $registryBackup->key;
        foreach ($registryKeys as $registryKey) {
            $this->rObject["task_source"]["backupRegistry"] = "true";
            $path = (string) $registryKey->path;
            $this->rObject["task_source"]["registryPaths"][] = addslashes($path);
        }
        $plugins = $xml->PLUGINS->plugin;
        foreach ($plugins as $plugin) {
            $this->rObject["task_source"]["backupPlugins"] = "true";
            //$guid = (string)str_replace(array("{","}"), "", $plugin->guid);
            $guid = (string) $plugin->guid;
            $this->rObject["task_source"]["selectedPlugins"][] = $guid;
        }
        /**
         * Destination
         **/
        $destinationRoot = $xml->DESTINATION->root;
        $destinationType = (int) $destinationRoot['rb'];
        switch ($destinationType) {
            case 1:
                $this->rObject["task_destination"]["backupDestinationType"] = "local_folder";
                $this->rObject["task_destination"]["localBackupFolder"] = addslashes($destinationRoot->pathlist);
                break;
            case 2:
                $this->rObject["task_destination"]["backupDestinationType"] = "lan_folder";
                $this->rObject["task_destination"]["lanBackupFolder"] = addslashes($destinationRoot->path);
                break;
            case 3:
                $this->rObject["task_destination"]["backupDestinationType"] = "ftp_folder";
                $this->rObject["task_destination"]["ftpHostname"] = (string) $destinationRoot->Host;
                $this->rObject["task_destination"]["ftpPort"] = (string) $destinationRoot->Port;
                $this->rObject["task_destination"]["ftpUsername"] = (string) $destinationRoot->UserName;
                $this->rObject["task_destination"]["ftpInitDir"] = (string) addslashes($destinationRoot->InitDir);
                $this->rObject["task_destination"]["ftpPassiveMode"] = (string) addslashes($destinationRoot->PsvMode);
                break;
            default:
                $this->rObject["task_destination"]["backupDestinationType"] = "local_folder";
                $this->rObject["task_destination"]["localBackupFolder"] = addslashes($destinationRoot->path);
                break;
        }
        /**
         * Options
         **/
        $archiveRoot = $xml->DESTINATION->archive;
        if ($archiveRoot == "true") {
            $this->rObject["task_options"]["useCompression"] = "zip";
            $this->rObject["task_options"]["compressionLevel"] = (string) $archiveRoot["quality"];
            $this->rObject["task_options"]["selfExtract"] = (string) $archiveRoot["selfextracting"];
            $this->rObject["task_options"]["splitArchives"] = (string) $archiveRoot["split"] != "" ? "true" : NULL;
            $this->rObject["task_options"]["splitArchivesAt"] = (string) bcdiv($archiveRoot["split"], "1048576", 2);
            if ($archiveRoot["security"] == "Zip")
                $this->rObject["task_options"]["useEncryption"] = "zip";
            if ($archiveRoot["security"] == "AES")
                $this->rObject["task_options"]["useEncryption"] = "aes";
        }
        /**
         * Scheduler
         **/
        $taskScheduled = $xml->GENERAL->SNotScheduled;
        $generalPart = $xml->GENERAL;
        if ($taskScheduled != "true") {
            if ($generalPart->SOneTimeRun != "") {
                $this->rObject["task_scheduler"]["scheduleType"] = "onetime";
                $sDate = $generalPart->SOneTimeRun["date"];
                $sTime = $generalPart->SOneTimeRun["time"];
                $dateTime = $this->getDateTime($sDate, $sTime);
                $this->rObject["task_scheduler"]["oneTimeRunDate"] = $dateTime["date"];
                $this->rObject["task_scheduler"]["oneTimeRunTime"] = $dateTime["time"];
            }
            if ($generalPart->SWindowsStartup == "true")
                $this->rObject["task_scheduler"]["scheduleType"] = "startup";
            if ($generalPart->SWindowsShutDown == "true")
                $this->rObject["task_scheduler"]["scheduleType"] = "shutdown";
            if ($generalPart->SWeeks == "true") {
                $this->rObject["task_scheduler"]["scheduleType"] = "dayofweek";
                switch ((int) $generalPart->SWeeks_when) {
                    case 0:
                        $this->rObject["task_scheduler"]["dayofweek_runtype"] = "startup";
                        break;
                    case 1:
                        $this->rObject["task_scheduler"]["dayofweek_runtype"] = "shutdown";
                        break;
                    case 2:
                        $this->rObject["task_scheduler"]["dayofweek_runtype"] = "ontime";
                        $date = $this->getDateTime(0, $generalPart->SWeeks_hour);
                        $this->rObject["task_scheduler"]["dayofweek_runontime"] = $date["time"];
                        break;
                    // Default intentionaly ommited
                }
                $this->rObject["task_scheduler"]["dayofweek_days"] = $this->cNumberToDays($generalPart->SWeeks_days);
            }
            if ($generalPart->SDays == "true") {
                $this->rObject["task_scheduler"]["scheduleType"] = "runevery";
                switch ((int) $generalPart->SDays_when) {
                    case 0:
                        $this->rObject["task_scheduler"]["runevery_runtype"] = "startup";
                        break;
                    case 1:
                        $this->rObject["task_scheduler"]["runevery_runtype"] = "shutdown";
                        break;
                    case 2:
                        $this->rObject["task_scheduler"]["runevery_runtype"] = "ontime";
                        $date = $this->getDateTime($generalPart->SDays_hour, $generalPart->SDays_hour);
                        $this->rObject["task_scheduler"]["runevery_ontime"] = $date["time"];
                        break;
                    // Default intentionaly ommited
                }
                $this->rObject["task_scheduler"]["runevery_workingDays"] = $this->cNumberToDays($generalPart->SWork_days);
                $this->rObject["task_scheduler"]["runevery_days"] = (string) $generalPart->SDays_days;
            }
            if ($generalPart->SHours == "true") {
                $this->rObject["task_scheduler"]["scheduleType"] = "runeveryhours";
                $date = $this->getDateTime($generalPart->SHours_hour, $generalPart->SHours_hour);
                $this->rObject["task_scheduler"]["runeveryhours_workingDays"] = $this->cNumberToDays($generalPart->SWork_days);
                $this->rObject["task_scheduler"]["runeveryhours_hours"] = (string) $generalPart->SHours_hours;
                $this->rObject["task_scheduler"]["runeveryhours_time"] = $date["time"];
                $this->rObject["task_scheduler"]["runeveryhours_tasksperday"] = (string) $generalPart->SHours_backups;
            }
        }
        if ($xml->GENERAL->CreateDesktopShortcut == "true")
            $this->setter($this->rObject["task_scheduler"]["rescheduleMissed"], "true");
        if ($xml->GENERAL->SRunMissed == "true")
            $this->setter($this->rObject["task_scheduler"]["createShortcut"], "true");
        return $this->rObject;
    }
}
