<?php
session_start();
$lang = $_SESSION['langString'];
error_reporting(0);
?>

function changeTab(tabName, formName) {
    form = document.getElementsByName(formName);
    form[0].next.defaultValue = tabName;
}


function loadEffects() {
    debugConsole = $("tbesDebugConsole");
    if (debugConsole) {
        debugConsole.setOpacity('0.5');
        debugConsole.addEvent('mouseover', function(e) { $('tbesDebugConsole').setOpacity('1.0'); });
        debugConsole.addEvent('mouseout', function(e) { $('tbesDebugConsole').setOpacity('0.1'); });
        debugConsole.makeDraggable({handle: 'tbesDebugConsoleMover'});
        debugConsole.makeResizable({handle: 'tbesDebugConsoleResizer'});

    }
}

function delPath(el) {
    element = $(el);
    cell = $(element.getParent());
    row = $(cell.getParent());
    row.remove();
}

function shutDownComputerAction(at) {
	if (at) {
			$('logOffAfter').checked = false;
	} else {
			$('shutDownAfter').checked = false;
	}
}

function splitArchiveAction(at) {
	if (at) {
			$('selfExtract').checked = false;
	} else {
			$('splitArchive').checked = false;
	}
}


function addPath() {
    element = $$('.fileSelector');
    nElements = element.length - 1;
    newElement = element[0].clone();
    button = newElement.getElementsBySelector('input')[1];
    text = newElement.getElementsBySelector('input')[0];

    origValue = element[0].getElementsBySelector('input')[0].value;
    deleteLink = new Element('a');
    deleteLink.onclick = function(){ delPath(this); }
    deleteLink.addClass('taskLinks');
    deleteLink.setHTML('<?=$lang['delete']?>');
    deleteLink.injectAfter(button);
    button.remove();
    text.setProperty('title',  origValue);
    text.name = "paths[]";
    if (origValue == "") return false;

    newElement.getElementsBySelector("td.input_name2")[0].setHTML('&nbsp');

    newElement.injectAfter(element[nElements]);
    element[0].getElementsBySelector('input')[0].value = '';
    element[0].getElementsBySelector('input')[0].focus();
}

function filesToggle() {
    elements = $$('.fileSelector, .fileSelectorHide')
    if(elements[0].className == "fileSelector") {
        elements.each( function(el){el.className = 'fileSelectorHide';} );
        return;
    }

    elements.each(function(el){el.className = 'fileSelector';});
}

function pluginsToggle() {
    elements = $$('.pluginLister');
    show = elements.getStyle('display');
    if (show[0] == "none")
    elements.setStyle('display', '');
    else {
    	elements.setStyle('display', 'none');
		$$(".pluginUncheck").forEach(function(el){el.checked = false;});
    }
}

function masksToggle() {
	elements = $$('.masksLister');
	show = elements.getStyle('display');
	if (show[0] == "none")
	elements.setStyle('display', '');
	else {
		elements.setStyle('display', 'none');
		$$(".masksUncheck").forEach(function(el){el.checked = false;});		
	}
}


//REGISTRY
function registryToggle() {
    elements = $$('.registrySelector, .registrySelectorHide');
    if(elements[0].className == "registrySelector") {
        elements.each( function(el){el.className = 'registrySelectorHide';} );
        return;
    }

    elements.each(function(el) { el.className = 'registrySelector';});
}

function addRegistryPath() {
    element = $$('.registrySelector');
    nElements = element.length - 1;
    newElement = element[0].clone();
    button = newElement.getElementsBySelector('input')[1];
    text = newElement.getElementsBySelector('input')[0];

    origValue = element[0].getElementsBySelector('input')[0].value;
    deleteLink = new Element('a');
    deleteLink.onclick = function(){delPath(this);}
    deleteLink.addClass('taskLinks');
    deleteLink.setHTML('<?=$lang['delete']?>');
    deleteLink.injectAfter(button);
    button.remove();

    text.setProperty('title',  origValue);
    text.name = "registryPaths[]";
    if (origValue == "") return false;
    newElement.getElementsBySelector("td.input_name2")[0].setHTML('&nbsp');
    newElement.injectAfter(element[nElements]);
    element[0].getElementsBySelector('input')[0].value = '';
    element[0].getElementsBySelector('input')[0].focus();
}



//DEST
function showDisplay(name) {
    arr = ['local_folder', 'lan_folder', 'ftp_folder'];
    for (i=0; i<=arr.length-1; i++) {
        id = arr[i] + '_display';
        if (arr[i] == name) {
            $(id).setStyle('display', 'block');
            continue;
        }
        $(id).setStyle('display', 'none');
    }
    return true;
}

// OPT
function setEncryption(at) {
    if (at == "zip") {
        $('zipCompression').checked = true;
        $('zipOptions').setStyle('display', 'block');
        $('passwords').setStyle('display', 'block');
       $('selfExtract').disabled = false;
        $('splitArchive').disabled = false;
//        $('incrementalMode').disabled = true;
//        $('differentialMode').disabled = true;
        return true;
    }

    if (at == "aes") {
        $('zipCompression').checked = true;
        $('zipOptions').setStyle('display', 'block');
        $('passwords').setStyle('display', 'block');
        $('selfExtract').disabled = true;
        $('splitArchive').disabled = true;
//      $('incrementalMode').disabled = true;
//      $('differentialMode').disabled = true;
        return true;
    }

    if (at == "none") {
        $('passwords').setStyle('display', 'none');
        $('selfExtract').disabled = false;
        $('splitArchive').disabled = false;
        return true;
    }
    return false;
}

function enableCompression(at) {
	var backupType = "<?echo $_SESSION["save"]["task_destination"]["backupDestinationType"]; ?>";
	var stackBackup = $("stackBackup").checked;
    if (at == "true") {
    	if (backupType == "ftp_folder" && stackBackup == false) {
        	$('incrementalMode').disabled = false;
        	$('differentialMode').disabled = false;
        }
        $('zipOptions').setStyle('display', 'block');

        if ($('aesEncryption').checked == false) {
            $('selfExtract').disabled = false;
            $('splitArchive').disabled = false;
        }

        return true;
    }
  	if (backupType == "ftp_folder" && stackBackup == false) {
        	$('incrementalMode').disabled = true;
        	$('differentialMode').disabled = true;
    }

    $('noEncryption').checked = true;
    //$('incrementalMode').disabled = false;
    //$('differentialMode').disabled = false;
    $('passwords').setStyle('display', 'none');
    $('zipOptions').setStyle('display', 'none');
    return true;
}


function enableStackBackup(at) {
	var backupType = "<?echo $_SESSION["save"]["task_destination"]["backupDestinationType"]; ?>";
	if (at) {
		$('incrementalMode').disabled = true;
		$('differentialMode').disabled = true;
		$('stackFileLimit').disabled = false;
		$('stackLastFiles').disabled = false;
		
	} else {
		if ($('zipCompression').checked == false && backupType == "ftp_folder") {
			$('incrementalMode').disabled = true;
			$('differentialMode').disabled = true;
		} else {
			$('incrementalMode').disabled = false;
			$('differentialMode').disabled = false;		
		}
		$('stackFileLimit').disabled = true;
		$('stackLastFiles').disabled = true;
	}
}

function enableDifferential(at) {
	if (at) {
		$('incrementalMode').checked = true;
	} else {
		if ($('incrementalMode').checked == false) $('differentialMode').checked = false;	
	}
}

function enableElements(elements) {
    name = "." + elements + "_elements";
    e = [".dayofweek_elements", ".runevery_elements", ".onetime_elements", ".runeveryhours_elements"];

    for (i=0;i<=e.length-1;i++) {
        if (e[i] == name) { $$(e[i]).each(function(el) { el.disabled=false }); continue; }
        $$(e[i]).each(function(el){el.disabled=true});
    }
}

function toggleDisplay(element) {
    if ($$(element)[0].getStyle("display") == "none") {
        $$(element)[0].setStyle("display", "");
    } else {
        $$(element)[0].setStyle("display", "none");
    }
}

function toggleTaskEvent(event_name) {
    types = new Array('showWindow', 'playSound', 'sendEmail');
    for (i=0;i<=types.length-1;i++) {
        eventName = '#' + event_name + "_" + types[i];
        eventElement = $$(eventName)[0];
        main = $('notifySummary_' + types[i]);
        if (main.checked == true) { eventElement.disabled = true; continue; }
        if (eventElement.disabled == true) eventElement.disabled = false;
        else  eventElement.disabled = true;
    }
}
function toggleTaskSubEvent(event_name) {
    types = ['notifyErrors', 'notifyWarnings'];
    for (i=0;i<=types.length-1;i++) {
        eventName = '#' + types[i] + '_' + event_name;
        eventElement = $$(eventName)[0];
        main = $('notifySummary_' + event_name);
        if (main.checked == true) eventElement.disabled=true;
        else eventElement.disabled=false;
    }
}

/*LISTING*/
function deleteTasks() {
    computers = $ES("input[name^=selected_tasks]").filterByAttribute('checked');
    if (computers.length == 0) { alert('<?=$lang['noTasksSelected']?>'); return false; }

    confirmation = confirm("<?=$lang['confirmTasks']?>");
    if (confirmation != true) return false;

    formName  = $('selectedTasksForm');
    formName.task_action.value = "delete";
    formName.submit();
    return formName;
}

function changeTabs(next) {
    if (document.doNotSubmit == true){
        alert("<?=$lang['checkForErrors']?>");
    } else {
    newElement = new Element('input');
    newElement.setProperty('type', 'hidden');
    newElement.setProperty('name', 'submit_action[next]');
    newElement.setProperty('value', 'next');

    nextElement = $($('task_form').next);
    nextElement.value = next;

    form = $('task_form');

    newElement.injectInside(form);
	form.submit();
    }
}

function saveTabs() {
    if (document.doNotSubmit == true){
        //NOTHING
    } else {
    newElement = new Element('input');
    newElement.setProperty('type', 'hidden');
    newElement.setProperty('name', 'submit_action[finish]');
    newElement.setProperty('value', 'Finish');

    //nextElement = $($('task_form').next);
    //nextElement.value = next;

    form = $('task_form');

    newElement.injectInside(form);

    form.submit();
    }
}


function goBackTabs() {
    if (document.doNotSubmit == true){
        //NOTHING
    } else {
    newElement = new Element('input');
    newElement.setProperty('type', 'hidden');
    newElement.setProperty('name', 'submit_action[back]');
    newElement.setProperty('value', 'back');

    form = $('task_form');
    newElement.injectInside(form);
    form.submit();
    }

}


function innerStartTask() {
    queryString = "task_action=start&fromedit=true&selected_tasks[]=" + document.taskID;
    var myAjax = new Ajax('/JSON/queue', {method: 'post', data:queryString, evalScripts:true});
    myAjax.request();
}

function updateName(ob) {
    currentText = $('taskName').value;
    folderText = $('archiveFolderName').value;
    $('archiveFolderName').value = currentText.replace(/ /g, '_');
    timelyCheck();
}

function validateSource() {
    gInput = $$("input.ffuncker")[0];
    rInput = $$("input.rfuncker")[0];
    doSubmit = true;
    rScore = gInput.value.length + rInput.value.length;
    if (rScore > 0) {
        var rConfirm = true;
        if (rConfirm) {
            if (gInput.value.length > 0) {
                addPath();
            }

            if (rInput.value.length > 0) {
                addRegistryPath();
            }
        }
    }
    return doSubmit;
}

/* Computer Events */
function deleteComputers() {

    formName  = $('selectedComputersForm');
    computers = $ES("input[name^=selected_computers]").filterByAttribute('checked');
    if (computers.length == 0) { alert('<?=$lang['noComputersSelected']?>'); return false; }

    confirmation = confirm("<?=$lang['confirmComputers']?>");
    if (confirmation != true) return false;

    
    formName.computer_action.value = "delete";
    formName.submit();
    return formName;
}

function approveComputers() {

    computers = $ES("input[name^=selected_computers]").filterByAttribute('checked');
    if (computers.length == 0) { alert('<?=$lang['noComputersSelected']?>'); return false; }

    confirmation = confirm("<?=$lang['approveComputers']?>");
    if (confirmation != true) return false;  

    formName  = $('selectedComputersForm');
    formName.computer_action.value = "approve";
    formName.submit();
    return formName;
}


/* Task JSON Actions and Such */
function startTasksRemote() {
    computers = $ES("input[name^=selected_tasks]").filterByAttribute('checked');
    if (computers.length == 0) { alert('<?=$lang['noTasksSelected']?>'); return false; }

    formElement = $('selectedTasksForm');
    formElement.task_action.value = 'start';
    queryString = formElement.toQueryString();

    var myAjax = new Ajax('/JSON/queue', {method: 'post', data:queryString, evalScripts:true});
    myAjax.request();
}

function stopTasksRemote() {
    computers = $ES("input[name^=selected_tasks]").filterByAttribute('checked');
    if (computers.length == 0) { alert('<?=$lang['noTasksSelected']?>'); return false; }

    formElement = $('selectedTasksForm');
    formElement.task_action.value = 'stop';
    queryString = formElement.toQueryString();

    var myAjax = new Ajax('/JSON/queue', {method: 'post', data:queryString, evalScripts:true});
    myAjax.request();
}

function restoreTasksRemote() {
    computers = $ES("input[name^=selected_tasks]").filterByAttribute('checked');
    if (computers.length == 0) { alert('<?=$lang['noTasksSelected']?>'); return false; }

    formElement = $('selectedTasksForm');
    formElement.task_action.value = 'restore';
    queryString = formElement.toQueryString();

    var myAjax = new Ajax('/JSON/queue', {method: 'post', data:queryString, evalScripts:true});
    myAjax.request();
}



function startTasksRemoteSingle() {
    computers = $ES("input[name^=selected_tasks]").filterByAttribute('checked');
    if (computers.length == 0) { alert('<?=$lang['noTasksSelected']?>'); return false; }

    formElement = $('selectedTasksForm');
    formElement.task_action.value = 'start';
    queryString = formElement.toQueryString();

    var myAjax = new Ajax('/JSON/squeue', {method: 'post', data:queryString, evalScripts:true});
    myAjax.request();
}

function stopTasksRemoteSingle() {
    computers = $ES("input[name^=selected_tasks]").filterByAttribute('checked');
    if (computers.length == 0) { alert('<?=$lang['noTasksSelected']?>'); return false; }

    formElement = $('selectedTasksForm');
    formElement.task_action.value = 'stop';
    queryString = formElement.toQueryString();

    var myAjax = new Ajax('/JSON/squeue', {method: 'post', data:queryString, evalScripts:true});
    myAjax.request();
}

function restoreTasksRemoteSingle() {
    computers = $ES("input[name^=selected_tasks]").filterByAttribute('checked');
    if (computers.length == 0) { alert('<?=$lang['noTasksSelected']?>'); return false; }

    formElement = $('selectedTasksForm');
    formElement.task_action.value = 'restore';
    queryString = formElement.toQueryString();

    var myAjax = new Ajax('/JSON/squeue', {method: 'post', data:queryString, evalScripts:true});
    myAjax.request();
}

function resendAll() {
    computers = $ES("input[name^=selected_computers]").filterByAttribute('checked');
    if (computers.length == 0) { alert('<?=$lang['noComputersSelected']?>'); return false; }

    formElement = $('selectedComputersForm');
    formElement.computer_action.value = 'resend';
    queryString = formElement.toQueryString();
    var myAjax = new Ajax('/JSON/compQueue', {method: 'post', data:queryString, evalScripts: true});
    myAjax.request();
}
function timelyCheck() {
    if (document.checkTimeout > 0)
            clearTimeout(document.checkTimeout);
    document.checkTimeout = setTimeout('checkNameValability()', 400);
}

function checkNameValability() {
    var taskName = $('taskName').value;
    var nameField = $('taskName');
    if (taskName == document.firstName) return true;
    
    var jSonRequest = new Json.Remote("/JSON/checkName?name="+escape(taskName), {method: 'post', onComplete: function(response){
        var isAvail = response.result;
        if (isAvail == false) {
            nameField.setStyle('background-color', 'red');
            document.doNotSubmit = true;
            $('taskDesc1').setStyle('display', 'none');
            $('taskDesc2').setStyle('display', 'block');
        } else {
            if (document.doNotSubmit == true) {
                $('taskDesc1').setStyle('display', 'block');
                $('taskDesc2').setStyle('display', 'none');        
                nameField.setStyle('background-color', '');
                document.doNotSubmit = false;
            }
       }
    }});
    jSonRequest.send();
}

function checkForErrors() {
    if (document.doNotSubmit == true){
        alert("<?=$lang['checkForErrors']?>");
        return false;
    }
    return true    
}

function viewQueue() {
    computers = $ES("input[name^=selected_computers]").filterByAttribute('checked');
    if (computers.length == 0) { alert('<?=$lang['noComputersSelected']?>'); return false; }

    formElement = $('selectedComputersForm');
    formElement.computer_action.value = 'resend';
    formElement.action = "<?=$fullURL?>/tools/computersqueue/type/imp";
    formElement.submit();
}

function clearQueue() {
    var myAjax = new Ajax('/JSON/clearQueue', {method: 'post', evalScripts: true});
    myAjax.request();
}



function selectChildren(el) {
    var locId = el.id;
    var children = $$('.' + locId + "_child");
    if (el.checked)
    children.setProperty('checked', 'checked');
    else
    children.setProperty('checked', '');
}


/* New paths */
function addStorePath() {
    element = $$('.fileSelector');
    nElements = element.length - 1;
    newElement = element[0].clone();
    button = newElement.getElementsBySelector('input')[1];
    text = newElement.getElementsBySelector('input')[0];

    origValue = element[0].getElementsBySelector('input')[0].value;
    deleteLink = new Element('a');
    deleteLink.onclick = function(){ delPath(this); }
    deleteLink.addClass('taskLinks');
    deleteLink.setHTML('<?=$lang['delete']?>');
    deleteLink.injectAfter(button);
    button.remove();
    text.setProperty('title',  origValue);
    text.name = "options[storePaths][]";
    if (origValue == "") return false;

    newElement.getElementsBySelector("td.inputNameAndDesc")[0].setHTML('&nbsp');

    newElement.injectAfter(element[nElements]);
    element[0].getElementsBySelector('input')[0].value = '';
    element[0].getElementsBySelector('input')[0].focus();
}

function taskPageLeave() {
	var leave = confirm("<?=$lang["taskPageLeave"]?>");
	return leave;
}

function taskPageCancel() {
	var leave = confirm("<?=$lang["taskPageCancel"]?>");
	return leave;
}

function testPage() {
	var expression = /\/tasks\/add/i;
	if (expression.test(window.location.pathname)) {
		alert(document.location);
		alert(document.referrer);
		alert(document.baseURI);		
		alert(document.documentURI);
		
	}
}

function verifySourcePage() {
	noContinue = false;
	checkboxes = $ES(".checkerbox2").filterByAttribute('checked');
	if (checkboxes.length == 0) noContinue = true;
	
	if (noContinue == true) {
		alert("Please select a valid source before you continue");
		return false;
	}
	return true;
}

//window.addEvent('unload', testPage);
window.addEvent('domready', loadEffects);