<?php
/**
 * Blank controller intended for management of the tools section
 * 
 * @author Nophinity
 * @version 0.0
 * @todo Finish it
 * @see Zend_Controller_Action
 * 
 */
class ToolsController extends Zend_Controller_Action
{
    /**
     * Blank
     *
     */
    function IndexAction ()
    {
        $smarty = new Custom_Smarty('Tools', 'updateclients.tpl', 'mainTemplate.tpl', 'toolsSubmenu.tpl');
        if ($_POST['usaction'] != "") {
            $options = $_POST['options'];
            $options['update_enabled'] = $_POST['options']['update_enabled'] == 1 ? 1 : 0;
            foreach ($options as $key => $value) {
                Options::set($key, $value);
            }
        }
        if ($_POST['usaction'] == "Resend Update Notification") {
            $_SESSION['forced_update'] = true;
            include ('cron/jobs/update_computers.php');
        }
        $smarty->assign('last_notification', Options::get('last_notification'));
        $smarty->assign('options', Options::getAll());
        $smarty->dumpT();
    }
    function tasksqueueAction ()
    {
        $db = Zend::registry('dbController');
        // /ViewQueue/tasks/view/task_id
        if (isset($_GET['deletecommand'])) {
            $db->delete('cmdqueue', $db->quoteInto('id = ?', $_GET['deletecommand']));
        }
        $smarty = new Custom_Smarty("Tools", "view_queue.tpl", "mainTemplate.tpl", "toolsSubmenu.tpl");
        $taskID = $this->_getParam('view', 0);
        $select = $db->select()->from('cmdqueue', array("cmdqueue.id AS cmd_id" , "cmdqueue.status AS cmd_status" , "computers.computer_name" , "tasks.task_name" , dateTimeSelect('cmdqueue.insert_date', 'insert_date') , "cmdqueue.cmd_name"));
        $select->joinLeft('computers', 'computers.comp_guid = cmdqueue.comp_guid');
        $select->joinLeft('tasks', 'tasks.id = cmdqueue.task_id');
        $select->order("cmdqueue.insert_date DESC");
        $sortType = $_GET['sorttype'] == "ASC" ? "DESC" : "ASC";
        $sortby = $_GET['sortby'];
        $smarty->assign('sortType', $sortType);
        if ($sortby != "") {
            $select->order("$sortby $sortType");
            $smarty->assign('sortby', $sortby);
        }
        if ($taskID != 0) {
            $select->where('task_id = ?', $taskID);
        }
        $result = $db->fetchAll($select);
        $smarty->assign('queue', $result);
        $smarty->dumpT();
    }
    function computersqueueAction ()
    {
        $db = Zend::registry('dbController');
        // /ViewQueue/tasks/view/task_id
        if (isset($_GET['deletecommand'])) {
            $db->delete('cmdqueue', $db->quoteInto('id = ?', $_GET['deletecommand']));
        }
        $smarty = new Custom_Smarty("Tools", "view_queue.tpl", "mainTemplate.tpl", "toolsSubmenu.tpl");
        $taskID = $this->_getParam('view', 0);
        $select = $db->select()->from('cmdqueue', array("cmdqueue.id AS cmd_id" , "cmdqueue.status AS cmd_status" , "computers.computer_name" , "tasks.task_name" , dateTimeSelect('cmdqueue.insert_date', 'insert_date') , "cmdqueue.cmd_name"));
        $select->joinLeft('computers', 'computers.comp_guid = cmdqueue.comp_guid');
        $select->joinLeft('tasks', 'tasks.id = cmdqueue.task_id');
        $select->order("cmdqueue.insert_date DESC");
        $sortType = $_GET['sorttype'] == "ASC" ? "DESC" : "ASC";
        $sortby = $_GET['sortby'];
        $smarty->assign('sortType', $sortType);
        if ($sortby != "") {
            $select->order("$sortby $sortType");
            $smarty->assign('sortby', $sortby);
        }
        if ($taskID != 0) {
            $select->where('comp_guid = ?', $taskID);
        }
        if (isset($_POST['selected_computers']) && $this->_getParam('type', 0) === "imp") {
            $comps = $_POST['selected_computers'];
            foreach ($comps as $compGuid) {
                $select->orWhere('cmdqueue.comp_guid = ?', $compGuid);
            }
        }
        try {
            $result = $db->fetchAll($select);
        } catch (Exception $e) {
            Zend::dump($e);
        }
        $smarty->assign('queue', $result);
        $smarty->dumpT();
    }
    function setupXmlAction ()
    {
        $request = $this->getRequest();
        $response = $this->getResponse();
        $response->clearAllHeaders();
        $serverName = $_SERVER['SERVER_NAME'];
        $serverPort = $_SERVER['SERVER_PORT'];
        $serverPath = str_replace('index.php', '', $_SERVER['PHP_SELF']);
        $xml = simplexml_load_string('<enterprise/>');
        $xml->addChild('domain', "$serverName");
        $xml->addChild('port', $serverPort);
        $xml->addChild('path', $serverPath);
        $xmlText = $xml->asXML();
        $domxml = new DOMDocument('1.0', 'UTF-8');
        $domxml->formatOutput = 1;
        $domnode = dom_import_simplexml($xml);
        $domnode = $domxml->importNode($domnode, true);
        $domnode = $domxml->appendChild($domnode);
        $body = $domxml->saveXML();
        $useragent = $_SERVER['HTTP_USER_AGENT'];
        //		if (strpos($useragent, 'MSIE')==false) {
        $response->setHeader('Cache-Control', 'no-store, must-revalidate, post-check=0, pre-check=0');
        $response->setHeader('Content-Description', 'File Transfer');
        $response->setHeader('Content-Type', 'application/octet-stream');
        $response->setHeader('Content-Length', strlen($body));
        $response->setHeader('Content-Disposition', 'attachment; filename=setup.xml');
        //		} else {
        //			$response->setHeader('Content-Type', 'text/xml');
        //		}
        $response->setBody($body);
    }
}