<script type="text/javascript">
{literal}
var TaskList = {
    start: function() {
        TaskList.refresh.periodical(2500);
        expandAllRows();
    },
    update: function(json) {
        result = json.result;
        for (i=0; i<result.length;i++) {
            taskData = result[i];
            taskID = taskData.guid;
            compID = taskData.owner;

            taskStatus = taskData.task_status.toLowerCase();
            elementStatus = $('status'+compID+"task"+taskID);
            if (elementStatus) {
                elementStatus.className = "status-"+taskStatus;
                elementStatus.innerHTML = taskStatus.capitalize();
            }

            nextRunTime = $('nrt'+compID+"task"+taskID);
            if (nextRunTime) {
                nextRunTime.innerHTML = taskData.next_run_time;
            }

            lastCompTime = $('lct'+compID+"task"+taskID);
            
            if (lastCompTime) {
                lastCompTime.innerHTML = taskData.last_completed_time;
            }

            lastRunTime = $('lrt'+compID+"task"+taskID);
            if (lastRunTime) {
                lastRunTime.innerHTML = taskData.last_run_time;
            }


            taskProgress = taskData.task_percentage;
            elementProgress = $('progressperc'+compID+'task'+taskID);
            elProg = $('progress'+compID+'task'+taskID);
            if (elProg) {
                if (taskStatus == "stopped" || taskStatus == "canceled") {
                    elProg.style.visibility = 'hidden';
                } else {
                    elProg.style.visibility = '';
                    fxProgress = new Fx.Style(elementProgress, 'width', {duration:500, unit:'%'});
                    fxProgress.start(elementProgress.getStyle('width').toInt(), taskProgress);
                    $('perc'+compID+'task'+taskID).innerHTML = taskProgress+"%";
                }
            } else {
                //console.log(taskID);
            }
        }
        if ($("#BIGOVERLAY")) $("#BIGOVERLAY").remove();
    },
    refresh: function() {
        var jsonRequest = new Json.Remote({/literal}"{$fullURL}JSON/tasks"{literal}, {onComplete: TaskList.update});
        jsonRequest.send();
    }

};

{/literal}
window.addEvent('domready', TaskList.start);
</script>
<h2>{$ls.allTasks}</h2>
  <button onclick="window.location.pathname='/tasks/add/view/new';">{$ls.newTask}</button>  
  
  <button onclick="deleteTasks();">{$ls.deleteTasks}</button>
  <button onclick="startTasksRemoteSingle();">{$ls.startTasks}</button>
  <button onclick="stopTasksRemoteSingle();">{$ls.stopTasks}</button>
  <button onclick="restoreTasksRemoteSingle();">{$ls.restoreTasks}</button>

  <button onclick="expandAllRows();">{$ls.expandAll}</button>
  <button onclick="collapseAllRows();">{$ls.collapseAll}</button>

  <button onclick='$$("input[type=checkbox]").setProperty("checked", "checked");'>{$ls.selectAll}</button>
  <button onclick='$$("input[type=checkbox]").setProperty("checked", "");'>{$ls.deselectAll}</button>

  
  <br style="clear: both;"/>  <br style="clear: both;"/>

<div class="window">
<div id="#BIGOVERLAY" style="background-color: black; position: fixed; width: 100%; height: 100%; opacity: 0.6; text-align: center; vertical-align: middle; z-index: 31337; filter: Alpha(opacity=60); cursor: wait; margin: 0; padding: 0; top: 0; left: 0;">
<h3 style="position: relative; top: 25%; color: white;">{$ls.loading}</h3>
<img src="/themes/default/images/loader.gif" alt="Loading" style="position: relative; top: 25%;"/>
</div>

<form id="selectedTasksForm" method="post" action="/tasks/list/all">
  <table class="computerWindow lister">
  
<tr class="header"><th style="width: 30%;">{$ls.path}</th><th style="width:4%">{$ls.nextRunTime}</th><th  style="width:4%">{$ls.lastRunTime}</th><th style="width:4%">{$ls.lastCompletedTime}</th><th>{$ls.status}</th><th>{$ls.progress}</th></tr>

  {foreach name=workloop from=$workgroups item=computers key=workgroup}  
<tr id="{$smarty.foreach.workloop.index}">
<td class="collapseable tier1" style="width: 30%;">
<img src="/themes/default/images/network.png" alt="Network"/>{$workgroup}</td>
<td style="text-align:center;">&nbsp;</td><td style="text-align:center;">&nbsp;</td>
<td style="text-align:center;">&nbsp;</td><td style="text-align:center;">&nbsp;</td>
<td style="text-align:center;">&nbsp;</td>
</tr>
{foreach from=$computers item=computer key=computers name=comploop}
<tr id="{$smarty.foreach.workloop.index}-{$smarty.foreach.comploop.index}">
{getUserTasks computer_name=$computer.compname workgroup=$workgroup}
<td class="tier2 {if $computerTasks|@count > 0}collapseable{/if}" {if $smarty.foreach.comploop.index % 2}style="background-color: #E9E9E9;"{/if}>
<img src="/themes/default/images/computer.png" alt="Computer"/>
{$computer.compname}
{getComputerStatus name=$computer.compname workgroup=$workgroup}
{if $computerStatus == true}(<span style="color:red;">Offline</span>){/if}
</td>
<td style="{if $smarty.foreach.comploop.index % 2}background-color: #E9E9E9;{/if}text-align:center;">&nbsp;</td><td  style="{if $smarty.foreach.comploop.index % 2}background-color: #E9E9E9;{/if}text-align:center;">&nbsp;</td>
<td style="{if $smarty.foreach.comploop.index % 2}background-color: #E9E9E9;{/if}text-align:center;">&nbsp;</td><td  style="{if $smarty.foreach.comploop.index % 2}background-color: #E9E9E9;{/if}text-align:center;">&nbsp;</td>
<td  style="{if $smarty.foreach.comploop.index % 2}background-color: #E9E9E9;{/if}text-align:center;">&nbsp;</td>

</tr>
{if $computerTasks|@count > 0}
<tr id="{$smarty.foreach.workloop.index}-{$smarty.foreach.comploop.index}-0">
<td style="text-align:left;{if $smarty.foreach.comploop.index % 2}background-color: #E9E9E9;{/if}" class="collapseable tier3">Admin Tasks</td><td style="text-align:center;{if $smarty.foreach.comploop.index % 2}background-color: #E9E9E9;{/if}">&nbsp;</td>
<td style="text-align:center;{if $smarty.foreach.comploop.index % 2}background-color: #E9E9E9;{/if}">&nbsp;</td><td style="text-align:center;{if $smarty.foreach.comploop.index % 2}background-color: #E9E9E9;{/if}">&nbsp;</td>
<td style="text-align:center;{if $smarty.foreach.comploop.index % 2}background-color: #E9E9E9;{/if}">&nbsp;</td><td style="{if $smarty.foreach.comploop.index % 2}background-color: #E9E9E9;{/if}">&nbsp;</td>
</tr>
{section name=tid loop=$computerTasks}
{if $computerTasks[tid].admin_task != 'No'}
<tr id="{$smarty.foreach.workloop.index}-{$smarty.foreach.comploop.index}-0-{$smarty.section.tid.index}">
<td class="task tier4" {if $smarty.foreach.comploop.index % 2}style="background-color: #E9E9E9;"{/if}>
<input type="checkbox" name="selected_tasks[{$computer.compguid}][]" value="{$computerTasks[tid].id}"  {if $computerTasks[tid].admin_task == 'No'}disabled{/if} />
<img src="{$fullURL}themes/default/images/task_icons/task_{$computerTasks[tid].task_type}.png" alt="Task"/>
{if $computerTasks[tid].admin_task == 'No'}
(User)<a href="javascript:alert('You Cannot edit a user task');" class="taskLinks">{$computerTasks[tid].task_name}</a>
{else}
<a href="{$fullURL}tasks/edit/view/{$computerTasks[tid].id}" class="taskLinks">{$computerTasks[tid].task_name}</a>
{/if}

</td>

<td {if $smarty.foreach.comploop.index % 2}style="background-color: #E9E9E9;"{/if}>
<div style="text-align: center;" id="nrt{$computer.compguid}task{$computerTasks[tid].guid}">{$ls.never}</div>
</td>
<td {if $smarty.foreach.comploop.index % 2}style="background-color: #E9E9E9;"{/if}>
<div style="text-align: center;" id="lrt{$computer.compguid}task{$computerTasks[tid].guid}">{$ls.never}</div>
</td>
<td {if $smarty.foreach.comploop.index % 2}style="background-color: #E9E9E9;"{/if}>
<div style="text-align: center;"  id="lct{$computer.compguid}task{$computerTasks[tid].guid}">{$ls.never}</div>
</td>

<td {if $smarty.foreach.comploop.index % 2}style="background-color: #E9E9E9;"{/if}>
<div style="text-align: center;"  id="status{$computer.compguid}task{$computerTasks[tid].guid}" class="status status-stopped">Stopped</div>
</td>
<td {if $smarty.foreach.comploop.index % 2}style="background-color: #E9E9E9;"{/if} width="25%">
<div style="visibility: hidden;" id="progress{$computer.compguid}task{$computerTasks[tid].guid}" class="progress">
<div id="progressperc{$computer.compguid}task{$computerTasks[tid].guid}" class="progress-perc" style="width: 0%;">
<span style="z-index:2" id="perc{$computer.compguid}task{$computerTasks[tid].guid}">0%</span>
</div>
</div>

</td>
</tr>
{/if}
{/section}

<tr id="{$smarty.foreach.workloop.index}-{$smarty.foreach.comploop.index}-1">
<td style="text-align:left; {if $smarty.foreach.comploop.index % 2}background-color: #E9E9E9;{/if}" class="collapseable tier3">User Tasks</td><td style="text-align:center; {if $smarty.foreach.comploop.index % 2}background-color: #E9E9E9;{/if}">&nbsp;</td>
<td style="text-align:center;{if $smarty.foreach.comploop.index % 2}background-color: #E9E9E9;{/if}">&nbsp;</td><td style="text-align:center;{if $smarty.foreach.comploop.index % 2}background-color: #E9E9E9;{/if}">&nbsp;</td>
<td style="text-align:center;{if $smarty.foreach.comploop.index % 2}background-color: #E9E9E9;{/if}">&nbsp;</td><td style="{if $smarty.foreach.comploop.index % 2}background-color: #E9E9E9;{/if}">&nbsp;</td>
</tr>
{section name=tid loop=$computerTasks}
{if $computerTasks[tid].admin_task != 'Yes'}
<tr id="{$smarty.foreach.workloop.index}-{$smarty.foreach.comploop.index}-1-{$smarty.section.tid.index}">
<td class="task tier4" {if $smarty.foreach.comploop.index % 2}style="background-color: #E9E9E9;"{/if}>
<input type="checkbox" name="selected_tasks[{$computer.compguid}][]" value="{$computerTasks[tid].id}"  {if $computerTasks[tid].admin_task == 'No'}disabled{/if} />
<img src="{$fullURL}themes/default/images/task_icons/task_{$computerTasks[tid].task_type}.png" alt="Task"/>
{if $computerTasks[tid].admin_task == 'No'}
{*<a href="javascript:alert('You Cannot edit a user task');" class="taskLinks">{$computerTasks[tid].task_name}</a>*}
<a href="{$fullURL}tasks/viewonly/view/{$computerTasks[tid].id}" class="taskLinks">{$computerTasks[tid].task_name}</a>

{else}
<a href="{$fullURL}tasks/edit/view/{$computerTasks[tid].id}" class="taskLinks">{$computerTasks[tid].task_name}</a>
{/if}

</td>

<td {if $smarty.foreach.comploop.index % 2}style="background-color: #E9E9E9;"{/if}>
<div style="text-align: center;" id="nrt{$computer.compguid}task{$computerTasks[tid].guid}">{$ls.never}</div>
</td>
<td {if $smarty.foreach.comploop.index % 2}style="background-color: #E9E9E9;"{/if}>
<div style="text-align: center;" id="lrt{$computer.compguid}task{$computerTasks[tid].guid}">{$ls.never}</div>
</td>
<td {if $smarty.foreach.comploop.index % 2}style="background-color: #E9E9E9;"{/if}>
<div style="text-align: center;"  id="lct{$computer.compguid}task{$computerTasks[tid].guid}">{$ls.never}</div>
</td>

<td {if $smarty.foreach.comploop.index % 2}style="background-color: #E9E9E9;"{/if}>
<div style="text-align: center;"  id="status{$computer.compguid}task{$computerTasks[tid].guid}" class="status status-stopped">Stopped</div>
</td>
<td {if $smarty.foreach.comploop.index % 2}style="background-color: #E9E9E9;"{/if} width="25%">
<div style="visibility: hidden;" id="progress{$computer.compguid}task{$computerTasks[tid].guid}" class="progress">
<div id="progressperc{$computer.compguid}task{$computerTasks[tid].guid}" class="progress-perc" style="width: 0%;">
<span style="z-index:2" id="perc{$computer.compguid}task{$computerTasks[tid].guid}">0%</span>
</div>
</div>

</td>
</tr>
{/if}
{/section}



{/if}

{/foreach}
{/foreach}  
  </table>
  <input type="hidden" name="task_action" value="" />
  </form>
  </div>
